---
title: ReadableStreamBYOBReader
slug: Web/API/ReadableStreamBYOBReader
tags:
  - API
  - Experimental
  - Fetch
  - Interface
  - ReadableStreamBYOBReader
  - Reference
  - Streams
---
<p>{{APIRef("Streams")}}{{SeeCompatTable}}</p>

<p><span class="seoSummary">The <code>ReadableStreamBYOBReader</code> interface of the <a href="/en-US/docs/Web/API/Streams_API">Streams API</a> represents a BYOB ("bring your own buffer") reader that can be used to read stream data supplied by the developer (e.g. a custom {{domxref("ReadableStream.ReadableStream","ReadableStream()")}} constructor).</span></p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("ReadableStreamBYOBReader.ReadableStreamBYOBReader", "ReadableStreamBYOBReader()")}}</dt>
 <dd>Creates and returns a <code>ReadableStreamBYOBReader</code> object instance.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("ReadableStreamBYOBReader.closed")}} {{readonlyInline}}</dt>
 <dd>Allows you to write code that responds to an end to the streaming process. Returns a promise that fulfills if the stream becomes closed or the reader's lock is released, or rejects if the stream errors.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("ReadableStreamBYOBReader.cancel()")}}</dt>
 <dd>Cancels the stream, signaling a loss of interest in the stream by a consumer. The supplied reason argument will be given to the underlying source, which may or may not use it.</dd>
 <dt>{{domxref("ReadableStreamBYOBReader.read()")}}</dt>
 <dd>Returns a promise providing access to the next chunk in the stream's internal queue.</dd>
 <dt>{{domxref("ReadableStreamBYOBReader.releaseLock()")}}</dt>
 <dd>Releases the reader's lock on the stream.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>TBD.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Streams','#byob-reader-class','ReadableStreamBYOBReader')}}</td>
   <td>{{Spec2('Streams')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>
<div class="hidden">
<p>The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>
</div>

<p>{{Compat("api.ReadableStreamBYOBReader")}}</p>
</div>
